package com.winhc.dataworks.flow.touch.bean;

import com.winhc.dataworks.flow.touch.utils.JsonUtils;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

import java.util.Map;
import java.util.stream.Collectors;

/**
 * @Author: XuJiakai
 * @Date: 2020/6/24 08:50
 * @Description:
 */
@Setter
@Getter
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class NodeParam {
    private String nodeId;
    private Map<String, String> param;

    public String toNodeParam(String bizDate) {
        param.put("bizdate", bizDate.replace("-", ""));
        return param.entrySet().stream()
                .filter(e -> !e.getKey().startsWith("_"))
                .filter(e-> StringUtils.isNotEmpty(e.getValue()))
                .map(e -> e.getKey() + "=" + e.getValue())
                .collect(Collectors.joining(" "));
    }

    @Override
    public String toString() {
        return JsonUtils.jsonObjToString(this);
    }
}
